import requests
import re
from bs4 import BeautifulSoup


class Loader(object):
    """
    Visits links generated by scanner, loads them, then stores them.
    Company name
    Company URL
    Apply URL
    Job description
    """

    def __init__(self, config):
        self.config = config
        self.top_element = config["top_element"]
        self.company_element = config["company_element"]
        self.company_name_parent_element = config["company_name_parent_element"]
        self.company_name_element = config["company_name_element"]
        self.apply_button_parent = config["apply_button_parent_element"]
        self.apply_button = config["apply_button_element"]
        self.job_description = config["job_description"]

        self.results_list = []

    def load(self, scanner_input):
        local_results = []
        for result in scanner_input:
            url = result["url"]
            html = requests.get(url).text
            soup = BeautifulSoup(html, "html5lib")
            top_element = soup.find(self.top_element)
            job_title = top_element.select_one(".jobsearch-JobInfoHeader-title-container h1")
            job_title_text = job_title.string
            company_name = top_element.select_one(".jobsearch-InlineCompanyRating div a")
            company_name_text = company_name.string
            company_link = company_name["href"]
            job_location = top_element.select_one(".jobsearch-InlineCompanyRating div:nth-of-type(4)")
            job_location_text = job_location.string
            # job_description = top_element.select(".jobDescriptionText")
            # job_description_text = job_description.strings

            print(job_title_text)
            print(company_name_text)
            print(company_link)
            print(job_location_text)
            # print(job_description_text)






    def dump(self):
        pass
